Ruby: pm_for_node Struct Reference

Ruby 3.4.8p72 (2025-12-17 revision 995b59f66677d44767ce9faac6957e5543617ff9)

Data Fields
pm_for_node Struct Reference

ForNode. More...

`#include <ast.h>`

## Data Fields
pm_node_t | base
| The embedded base node.
struct pm_node * | index
| ForNode#index.
struct pm_node * | collection
| ForNode#collection.
struct pm_statements_node * | statements
| ForNode#statements.
pm_location_t | for_keyword_loc
| ForNode#for_keyword_loc.
pm_location_t | in_keyword_loc
| ForNode#in_keyword_loc.
pm_location_t | do_keyword_loc
| ForNode#do_keyword_loc.
pm_location_t | end_keyword_loc
| ForNode#end_keyword_loc.
Data Fields inherited from pm_node
pm_node_type_t | type
| This represents the type of the node.
pm_node_flags_t | flags
| This represents any flags on the node.
uint32_t | node_id
| The unique identifier for this node, which is deterministic based on the source.
pm_location_t | location
| This is the location of the node in the source.

## Detailed Description

ForNode.

Represents the use of the for keyword.

    for i in a end
    ^^^^^^^^^^^^^^

Type: ::PM_FOR_NODE

Definition at line 3962 of file ast.h.

## Field Documentation

## ◆ base

pm_node_t pm_for_node::base

The embedded base node.

Definition at line 3964 of file ast.h.

Referenced by pm_dump_json().

## ◆ collection

struct pm_node* pm_for_node::collection

ForNode#collection.

The collection to iterate over.

    for i in a end
             ^

Definition at line 3985 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ do_keyword_loc

pm_location_t pm_for_node::do_keyword_loc

ForNode#do_keyword_loc.

The location of the do keyword, if present.

    for i in a do end
               ^^

Definition at line 4027 of file ast.h.

Referenced by pm_dump_json().

## ◆ end_keyword_loc

pm_location_t pm_for_node::end_keyword_loc

ForNode#end_keyword_loc.

The location of the end keyword.

    for i in a end
               ^^^

Definition at line 4037 of file ast.h.

Referenced by pm_dump_json().

## ◆ for_keyword_loc

pm_location_t pm_for_node::for_keyword_loc

ForNode#for_keyword_loc.

The location of the for keyword.

    for i in a end
    ^^^

Definition at line 4007 of file ast.h.

Referenced by pm_dump_json().

## ◆ in_keyword_loc

pm_location_t pm_for_node::in_keyword_loc

ForNode#in_keyword_loc.

The location of the in keyword.

    for i in a end
          ^^

Definition at line 4017 of file ast.h.

Referenced by pm_dump_json().

## ◆ index

struct pm_node* pm_for_node::index

ForNode#index.

The index expression for for loops.

    for i in a end
        ^

Definition at line 3975 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ statements

struct pm_statements_node* pm_for_node::statements

ForNode#statements.

Represents the body of statements to execute for each iteration of the loop.

    for i in a
      foo(i)
      ^^^^^^
    end

Definition at line 3997 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

The documentation for this struct was generated from the following file:

- prism/ast.h